<?php
// command/Command.php
// qframe license: http://resources.corrosive.co.uk/pkg/qframe/license.txt

abstract class Command {
    const     CMD_SUCCESS = 200;
    const CMD_UNPROCESSED = 400;
    const       CMD_ERROR = 500;

    final function execute( RequestHelper $requestHelper ) {
        $status = $this->doExecute( $requestHelper );
        $requestHelper->registerCommand( get_class( $this ), $status );
        return $status;
    }

    abstract protected function doExecute( RequestHelper $requestHelper );
}
?>