<?php
// controller/ApplicationResourcesImpl.php
// qframe license: http://resources.corrosive.co.uk/pkg/qframe/license.txt

require_once 'ApplicationResources.php';
require_once 'SimpleDispatcher.php';
require_once '../command/DataStore.php';
require_once '../command/Command.php';
require_once '../command/SimpleCommandFactory.php';

class ApplicationResourcesImpl extends ApplicationResources {
   private $dispatcher;
   private $commandfactory;

   function __construct() {
        $this->dispatcher = new SimpleDispatcher( "../views" );
        $this->commandfactory = new SimpleCommandFactory();
   }

   function init() {
        $this->commandfactory->addPackage("/usr/local/www/php24/my_commands");
        $this->commandfactory->setDefaultCommand( "MyDefault" );
        $this->setupDispatcher();
        $this->primeDatabase();
   }

   function primeDatabase() {
        $user = "p24_user";
        $pass = "cwaffie";
        $host = "localhost";
        $database = "p24";

        $dsn = "mysql://$user:$pass@$host/$database";
        $store  = DataStore::getInstance();
        $store->setVar( "dsn", $dsn );
   }

   function setupDispatcher() {
        $success = Command::CMD_SUCCESS;
        $unproc  = Command::CMD_UNPROCESSED;
        $error   = Command::CMD_ERROR;

        $this->dispatcher->addCondition( "MyDefault", "main.php" );
        $this->dispatcher->addCondition( "MyDefault", "error.php", $error );
        $this->dispatcher->addCondition( "AddTask"  , "add.php"  );
        $this->dispatcher->addCondition( "AddTask"  , "main.php", $success );
        return true;
   }

   function getDispatcher() {
       return $this->dispatcher;
   }

   function getCommandFactory() {
       return $this->commandfactory;
   }
}
?>
