<?php
// controller/Controller.php
// qframe license: http://resources.corrosive.co.uk/pkg/qframe/license.txt

require_once 'ApplicationResources.php';
require_once 'RequestHelper.php';
require_once '../command/CommandFactory.php';

class Controller {
   private $applicationResources;

   function __construct( ApplicationResources $res ) {
      $this->applicationResources = $res;
      $res->init();
   }

   function handleRequest() {
      $command;
      $requestHelper = new RequestHelper();
      $com_factory = $this->applicationResources->getCommandFactory();
      try {
          $command = $com_factory->getCommand( $requestHelper );
          $command->execute( $requestHelper );
          $this->applicationResources->getDispatcher()->dispatch( $requestHelper );
       } catch ( Exception $e ) {
          throw $e;
     }
   }
}
?>
