<?php
// controller/Dispatcher.php
// qframe license: http://resources.corrosive.co.uk/pkg/qframe/license.txt

require_once 'RequestHelper.php';

class DispatchException extends Exception { }

abstract class Dispatcher {
   private $views;

   function __construct( $view_dir ) {
      $this->views = $view_dir;
   }

   abstract function getNext( RequestHelper $helper );

   function dispatch( RequestHelper $requestHelper ) {

       $next = $this->getNext( $requestHelper );
       $view = "{$this->views}/$next";

       if ( ! is_file( $view ) ) {
           throw new DispatchException( "   $view" );
       }

       include( $view );
       exit;
   }
}
?>