<?php

class date_pulldown {
  private $name;
  private $timestamp = -1;
  private $months = array ("", "", "", "", "",
           "","", "", "", "", "", "");
  private $yearstart = -1;
  private $yearend = -1;

  function __construct( $name ) {
    $this->name = $name;
  }

  function setDate_request( ) {
    if ( ! $this->setDate_array( $_REQUEST[$this->name])){
      return $this->setDate_timestamp( time() );
    }
    return true;
  }

  function setDate_timestamp( $time ) {
    $this->timestamp = $time;
    return true;
  }

  function setDate_array( $inputdate ) {
    if ( is_array( $inputdate ) &&
      isset( $inputdate['mon'] ) &&
      isset( $inputdate['mday'] ) &&
      isset( $inputdate['year'] ) ) {
      $this->timestamp = mktime( 11, 59, 59,
        $inputdate['mon'],
        $inputdate['mday'], $inputdate['year']);
      return true;
    }

    return false;
  }

  function setYearStart( $year ) {
    $this->yearstart = $year;
  }

  function setYearEnd( $year ) {
    $this->yearend = $year;
  }

  function getYearStart() {
    if ( $this->yearstart < 0 ) {
      $nowarray = getdate( time() );
      $this->yearstart = $nowarray['year']-5;
    }
    return $this->yearstart;
  }

  function getYearEnd() {
    if ( $this->yearend < 0 ) {
      $nowarray = getdate( time() );
      $this->yearend = $nowarray['year']+5;
    }
    return $this->yearend;
  }

  function output( ) {
    if ( $this->timestamp < 0 ) {
      $this->setDate_request();
    }
    $datearray = getdate( $this->timestamp );
    $out  = $this->day_select  ( $this->name, $datearray );
    $out .= $this->month_select( $this->name, $datearray );
    $out .= $this->year_select ( $this->name, $datearray );
    return $out;
  }

  function day_select( $fieldname, $datearray ) {
    $out = "<select name=\"$fieldname" . "[mday]\">\n";
    for ( $x=1; $x<=31; $x++ ) {
      $selected = ($datearray['mday']==($x)?' selected="selected"':"");
      $out .= "<option value=\"$x\"$selected>" . sprintf("%02d", $x );
      $out .= "</option>\n";
    }
    $out .= "</select>\n";
    return $out;
  }

  function month_select( $fieldname, $datearray ) {
    $out = "<select name=\"$fieldname" . "[mon]\">\n";
    for ( $x = 1; $x <= 12; $x++ ) {
      $selected = ($datearray['mon']==($x)?' selected="selected"':"");
      $out .= "<option value=\"$x\"$selected>"
           . $this->months[$x-1];
      $out .= "</option>\n";
    }
    $out .= "</select>\n";
    return $out;
  }

  function year_select( $fieldname, $datearray ) {
    $out = "<select name=\"$fieldname"."[year]\">";
    $start = $this->getYearStart();
    $end = $this->getYearEnd();
    for ( $x= $start; $x < $end; $x++ ) {
      $selected = ($datearray['year']==($x)?' selected="selected"':"");
      $out .= "<option value=\"$x\"$selected>$x";
      $out .= "</option>\n";
    }
    $out .= "</select>\n";
    return $out;
  }
}


?>