<?php
// facade/TaskFacade.php
// qframe license: http://resources.corrosive.co.uk/pkg/qframe/license.txt

require_once 'DB.php';

class TaskFacade {
   private $db_common;

   function __construct() {
   //  getConnection()  
       $this->db_common = $this->getConnection();
   }

   private function getConnection() {
       $data = DataStore::getInstance();
        $dsn = $data->getVar("dsn");
        if ( empty( $dsn ) ) {
           throw new TaskFacadeException( "  'dsn'" );
        }
        $connection = DB::connect( $dsn );
        if ( DB::isError( $connection ) ) {
           throw new TaskFacadeException( $connection->getMessage() );
        }
       return $connection;
   }

   private function selectQuery( $query ) {
       $result = $this->db_common->query( $query );
       if ( $result instanceof db_error ) {
            throw new TaskFacadeException( $result->getMessage() );
       }

       $ret = array();
       while ( $row = $result->fetchRow( DB_FETCHMODE_ASSOC ) ) {
            foreach ( $row as $key=>$val ) {
            $row[$key] = stripslashes( $val );
            }
            $ret[] = $row;
       }
       return $ret;
   }

   function getTask( $id ) {
      $query = "SELECT * FROM tasks WHERE id=$id";
      //  selectQuery()   
      return $this->selectQuery( $query );
   }

   function getTasks() {
      $query = "SELECT * FROM tasks";
      //  selectQuery()   
      $result = $this->selectQuery( $query );
       return $result;
   }

   function setTask( $data_array ) {
       if ( ! is_array( $data_array )) {
          throw new TaskFacadeException( " setTask()  " );
       }

       if (  empty( $data_array['summary'] ) ||
             empty( $data_array['person' ] ) ) {
             throw new TaskFacadeException( " setTask():  " );
       }
       $fields = array( "person", "summary", "description" );
       foreach ( $fields as $key ) {
          $add_array[$key] = $data_array[$key];
       }

       $data_array['id'] = $this->db_common->nextId("tasks");
       $result = $this->db_common->autoExecute( "tasks", $add_array,
                                                 DB_AUTOQUERY_INSERT );
       if ( $result instanceof db_error ) {
            throw new TaskFacadeException( $result->getMessage() );
       }
       return true;
   }
}

class TaskFacadeException extends Exception { }

?>
