<?php
  header("Content-type: image/png");

  class SimpleBar {

   private     $xgutter = 20; //  / 
   private     $ygutter = 20; //  / 
   private $bottomspace = 30; //    
   private $internalgap = 10; //    
   private $cells  = array(); //   
   private       $totalwidth; //  
   private      $totalheight; //  
   private             $font; // 

   function __construct( $width, $height, $font ) {
        $this->totalwidth  = $width ;
        $this->totalheight = $height;
        $this->font        = $font  ;
   }

   function addBar( $label, $amount ) {
        $this->cells[ $label ] = $amount;
   }

   private function _getTextSize( $cellwidth ) {
        $textsize = (int)($this->bottomspace);

        if ( $cellwidth < 10 ) {
           $cellwidth = 10;
        }

        foreach ( $this->cells as $key => $val ) {
           while ( true ) {
             $box=ImageTTFbbox($textsize,0,$this->font,$key);
             $textwidth = abs( $box[2] );
             if ( $textwidth < $cellwidth ) {
                 break;
             }
             $textsize--;
           }
        }
        return $textsize;
   }

   function draw() {
        $image = imagecreate( $this->totalwidth, $this->totalheight );
        $red   = ImageColorAllocate($image, 255, 0, 0);
        $blue  = ImageColorAllocate($image, 0, 0, 255 );
        $black = ImageColorAllocate($image, 0, 0, 0 );
      
        $max   = max  ( $this->cells );
        $total = count( $this->cells );
        $graphCanX = ($this->totalwidth  - ($this->xgutter) * 2);
        $graphCanY = ($this->totalheight - ($this->ygutter) * 2
                   -  $this->bottomspace );
        $posX = $this->xgutter;
        $posY = $this->totalheight - $this->ygutter 
              - $this->bottomspace;

        $cellwidth = (int)(( $graphCanX 
                   - ( $this->internalgap * ( $total-1 ) )) / $total) ;
        $textsize = $this->_getTextSize( $cellwidth );
      
        foreach ( $this->cells as $key => $val ) {
           $cellheight = (int)(($val/$max) * $graphCanY);
           $center     = (int)($posX+($cellwidth/2));
           imagefilledrectangle( $image, $posX, 
                       ($posY-$cellheight),($posX+$cellwidth),$posY,$blue);
           $box = imageTTFbBox($textsize,0,$this->font,$key);
           $tw = $box[2];
           ImageTTFText($image,$textsize,0,($center-($tw/2)),
               ($this->totalheight-$this->ygutter), $black,
                $this->font, $key );
           $posX += ( $cellwidth + $this->internalgap);
        }
     
        imagepng( $image );
      }
    }
    
    $graph = new SimpleBar( 500, 300, "PTR76__C.TTF" );
    $graph->addBar( ""   , 200 );
    $graph->addBar( ".", 400 );
    $graph->addBar( ".", 900 );
    $graph->draw();
?>
