<?php
  include_once( "listing16.4.php" );

  class QuickCalendar {
      private $cellno=0;
      private $month;
      private $year;
      private $dateIterator;
     
      function __construct( $month, $year ) {
        if ( empty( $month ) || empty( $year ) ) {
          $nowArray = getdate();
          $year = $nowArray['year'];
          $month = $nowArray['mon'];
        }
   
        $this->dateIterator=new DateIterator($month,1,$year);
        $this->month = $month;
        $this->year = $year;
      }
         
      function getCurrentArray() {
        return $this->dateIterator->getPointerArray();
      }
     
      function cellBeforeMonthStart() {
        return ( ($this->cellno) <
                  $this->dateIterator->getMonthStartWDay() );
      }
       
      function cellAfterMonthEnd() {
        $current = $this->getCurrentArray();
        if ($this->month == 12) {
            return ( ($this->year) < $current['year'] );
        }
        return ( ($this->month) < ($current['mon']) );
      }
    
      function endOfRow() {
        return ( ! ( $this->cellno % 7 ) );
      }
   
      function endOfGrid() {
        return ( $this->cellAfterMonthEnd()
              && $this->endOfRow() );
      }
    
      function nextCell() {
        if ( $this->endOfGrid() ) {
           $ret = null;
        } else if ( $this->cellBeforeMonthStart() ||
                    $this->cellAfterMonthEnd()  ) {
           $ret = array();
        } else {
          $ret = $this->getCurrentArray();
          $this->dateIterator->incrementDay();
        }
        $this->cellno++;
        return $ret;
      }
    }
?>
