<?php

 class MyException extends Exception {
   public function summarize() {
      $ret  = "<pre>\n";
      $ret .= ": " . $this->getMessage() . "\n"
           . ": "     . $this->getCode()    . "\n"
           . ": "  . $this->getLine()    . "\n"
           . ": "    . $this->getFile()    . "\n";
      $ret .= "</pre>\n";
      return $ret;
   }
 }

 class FileNotFoundException extends MyException { }

 class FileOpenException extends MyException { }

 class Reader {
   function getContents( $file ) {
     if ( ! file_exists( $file ) ) {
        throw new FileNotFoundException( " '$file'  .", 1 );
     }
     $fp = @fopen( $file, 'r' );
     if ( ! $fp ) {
        throw new FileOpenException( "    '$file'.", 2 );
     }
     while ( ! feof( $fp ) ) {
        $ret .= fgets( $fp, 1024 );
     }
     fclose( $fp );
     return $ret;
   }
 }

 $reader = new Reader();
 try {
    print $reader->getContents( "blah.txt" );
 } catch ( FileNotFoundException $e ) {
    print $e->summarize();
 } catch ( FileOpenException $e ) {
    print $e->summarize();
 } catch ( Exception $e ) {
    die(" ");
 }
?>
