<?php
  $parser = xml_parser_create();

  xml_parser_set_option( $parser, XML_OPTION_CASE_FOLDING, 0 );
  xml_set_element_handler( $parser, "start_handler", "end_handler" );
  xml_set_character_data_handler( $parser, "char_data" );
 
  $xml_str = file_get_contents( "listing22.1.xml.rus", 0 );
 
  xml_parse( $parser, $xml_str ) or die( format_error( $parser ) );

  function start_handler( $parser, $el_name, $attribs ) {
     print "START: $el_name: <br />\n";
     foreach( $attribs as $at_name => $at_val ) {
        print "\t$at_name => \"$at_val\"<br />\n";
     }
     print "\t<blockquote><div>\n";
  }

  function end_handler( $parser, $el_name ) {
     print "\t</div></blockquote>\n";
     print "END: $el_name<br />\n";
  }

  function char_data( $parser, $data ) {
     print "\tchar data:<i>" . trim($data) . "</i><br />\n";
  }

  function format_error( $p ) {
     $code = xml_get_error_code( $p );
     $str = xml_error_string( $code );
     $line = xml_get_current_line_number ( $p );
     return "XML ERROR ($code): $str at line $line";
  }
?>
