<?php
  $open_stack = array();
  $parser     = xml_parser_create();
  xml_set_element_handler( $parser, "start_handler", "end_handler" );
  xml_set_character_data_handler( $parser, "character_handler");
  xml_parser_set_option( $parser, XML_OPTION_CASE_FOLDING, 0 );
  xml_parse( $parser, file_get_contents( "listing22.1.xml.rus" ))
      or die( format_error( $parser ) );
  xml_parser_free( $parser );

  function start_handler( $p, $name, $atts ) {
     global $open_stack;
     $open_stack[] = array($name, "");
  }

  function character_handler( $p, $txt ) {
     global $open_stack;
     $cur_index = count($open_stack)-1;
     $open_stack[$cur_index][1] =
     $open_stack[$cur_index][1] . $txt;
  }

  function end_handler( $p, $name ) {
     global $open_stack;
     $el = array_pop( $open_stack );
     if ( $name == "headline") {
          print "<p><b>$el[1]</b><br />\n";
     }
     if ( $name == "byline") {
          print "<i>$el[1]</i></p>\n\n";
     }
  }

  function format_error( $p ) {
     $code = xml_get_error_code( $p ); 
     $str = xml_error_string( $code );
     $line = xml_get_current_line_number ( $p );
     return "XML ERROR ($code): $str at line $line";
  }

?>
